<?php
/* 
 * TagCloud505 プラグイン
 */
class TagCloud505 extends SC_Plugin_Base {

    /**
     * コンストラクタ
     *
     */
    public function __construct(array $arrSelfInfo) {
        parent::__construct($arrSelfInfo);
    }

    /**
     * インストール
     * installはプラグインのインストール時に実行されます.
     * 引数にはdtb_pluginのプラグイン情報が渡されます.
     *
     * @param array $arrPlugin plugin_infoを元にDBに登録されたプラグイン情報(dtb_plugin)
     * @return void
     */
    function install($arrPlugin) {
        if(copy(PLUGIN_UPLOAD_REALDIR . "TagCloud505/logo.png", PLUGIN_HTML_REALDIR . "TagCloud505/logo.png") === false);
        // nop
    }

    /**
     * アンインストール
     * uninstallはアンインストール時に実行されます.
     * 引数にはdtb_pluginのプラグイン情報が渡されます.
     * 
     * @param array $arrPlugin プラグイン情報の連想配列(dtb_plugin)
     * @return void
     */
    function uninstall($arrPlugin) {
        TagCloud505::disable($arrPlugin);
        if(unlink(PLUGIN_HTML_REALDIR . "TagCloud505/logo.png") === false);
        if(unlink(PLUGIN_HTML_REALDIR . "TagCloud505/call.php") === false);
        if(unlink(PLUGIN_HTML_REALDIR . "TagCloud505/jquery.tagsphere.min.js") === false);
        if(rmdir(PLUGIN_HTML_REALDIR . "TagCloud505") === false);
    }
    
    /**
     * アップデート
     * updateはアップデート時に実行されます.
     * 引数にはdtb_pluginのプラグイン情報が渡されます.
     * 
     * @param array $arrPlugin プラグイン情報の連想配列(dtb_plugin)
     * @return void
     */
    function update($arrPlugin) {
        // nop
    }

    /**
     * 稼働
     * enableはプラグインを有効にした際に実行されます.
     * 引数にはdtb_pluginのプラグイン情報が渡されます.
     *
     * @param array $arrPlugin プラグイン情報の連想配列(dtb_plugin)
     * @return void
     */
    function enable($arrPlugin) {
    	$objQuery =& SC_Query_Ex::getSingletonInstance();
        $arrBloc = TagCloud505::getList();

        $sql_default = "INSERT INTO dtb_bloc (device_type_id, bloc_id, bloc_name, tpl_path, filename, create_date, update_date, php_path, deletable_flg) ";
        foreach ($arrBloc AS $val) {
            $sql = "${sql_default} VALUES (10, (SELECT max(bloc_id)+1 FROM dtb_bloc WHERE device_type_id = 10), '" . $val['bloc_name'] . "', '" . $val['filename'] . ".tpl', '" . $val['filename'] . "', CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, '" . $val['php_path'] . "', 0);";
    	    $objQuery->query($sql);
            //if(copy($val['php_path_from'], $val['php_path_to']) === false);
            if(copy($val['tpl_path'], TEMPLATE_REALDIR . "frontparts/bloc/" . $val['filename'].'.tpl') === false);
        }

        // シーケンスセット
        $sql = "SELECT setval('dtb_bloc_bloc_id_seq',(SELECT max(bloc_id) FROM dtb_bloc))";
    	$objQuery->query($sql);

        if(copy(PLUGIN_UPLOAD_REALDIR . "TagCloud505/call.php", PLUGIN_HTML_REALDIR . "TagCloud505/call.php") === false);
        if(copy(PLUGIN_UPLOAD_REALDIR . "TagCloud505/jquery.tagsphere.min.js", PLUGIN_HTML_REALDIR . "TagCloud505/jquery.tagsphere.min.js") === false);
    }

    /**
     * 停止
     * disableはプラグインを無効にした際に実行されます.
     * 引数にはdtb_pluginのプラグイン情報が渡されます.
     *
     * @param array $arrPlugin プラグイン情報の連想配列(dtb_plugin)
     * @return void
     */
    function disable($arrPlugin) {
    	$objQuery =& SC_Query_Ex::getSingletonInstance();
        if(unlink(PLUGIN_HTML_REALDIR . "TagCloud505/call.php") === false);

        $arrBloc = TagCloud505::getList();
        foreach ($arrBloc AS $val) {
    	    $bloc_id = $objQuery->get('bloc_id', 'dtb_bloc', 'filename = ?', array($val['filename']));
    	    $objQuery->delete('dtb_blocposition', 'bloc_id = ?', array($bloc_id));
    	    $objQuery->delete('dtb_bloc', 'bloc_id = ?', array($bloc_id));
        }
    }

    /**
     * 処理の介入箇所とコールバック関数を設定
     * registerはプラグインインスタンス生成時に実行されます
     * 
     * @param SC_Helper_Plugin $objHelperPlugin 
     * @return void
     */
    function register(SC_Helper_Plugin $objHelperPlugin) {
        // nop
    }

    function getList() {
        $p_name = '【TagCloud505】';
        $tpl_path = PLUGIN_UPLOAD_REALDIR . 'TagCloud505/templates/frontparts/bloc/';
        $php_path_from = PLUGIN_UPLOAD_REALDIR . "TagCloud505/";
        $php_path_to = PLUGIN_HTML_REALDIR . 'TagCloud505/';
        $php_path = ROOT_URLPATH . 'plugin/TagCloud505/';

        $arrBloc = array();

        $type = 'tag_cloud';
        $arrBloc[1]['bloc_name'] = "${p_name}タグクラウドブロック";
        $arrBloc[1]['filename'] = $type;
        $arrBloc[1]['tpl_path'] = "${tpl_path}${type}.tpl";
        //$arrBloc[1]['php_path_from'] = "${php_path_from}${type}.php";
        //$arrBloc[1]['php_path_to'] = "${php_path_to}${type}.php";
        $arrBloc[1]['php_path_from'] = "";
        $arrBloc[1]['php_path_to'] = "";
        //$arrBloc[1]['php_path'] = "${php_path}${type}.php";

        return $arrBloc;
    }


}

