<?php

class SC_Boundio {

    function init() {
        $this->serial = "";  //**ユーザーシリアルID
        $this->key = "";  //**アプリケーションキー
        $this->tel_to = "";  //**架電先電話番号
        $this->cast = "file(000002)%%file(000002)";  //**再生ファイルのID

        $this->convErr[1] = 'ユーザーシリアルID、もしくはユーザー認証キーの認証に失敗';
        $this->convErr[2] = '引数不足・ファイル容量制限オーバー';
        $this->convErr[3] = 'ファイルI/Oエラー';
        $this->convErr[4] = 'convtextの文字数制限エラー';
        $this->convErr[5] = 'アップロードファイル変換失敗';
        $this->convErr[6] = '音声合成変換失敗';
        $this->convErr[99] = 'システムエラー・その他不明なエラー';

        $this->callErr[1] = 'ユーザーシリアルID、もしくはAPIアクセスキーの認証に失敗';
        $this->callErr[2] = '電話番号の書式エラー';
        $this->callErr[3] = '音声ファイルなし';
        $this->callErr[4] = 'ポイント不足';
        $this->callErr[5] = 'アプリケーションの電話番号エラー';
        $this->callErr[99] = 'システムエラー・その他不明なエラー';
    }


    function call() {
        $url = "https://boundio.jp/api/vd1/" . $this->serial . "/call";
        $postdata = array(
                          "key" => $this->key,
                          "tel_to" => $this->tel_to,
                          "cast" => $this->cast
                         );
        $stream = stream_context_create(array(
        	  "http" => array(
        		"method" => "POST",
        		"header" => "Content-type: application/x-www-form-urlencoded",
        		"content" => http_build_query($postdata)
        	)
        ));

        $result = file_get_contents($url, false, $stream);
        $ret = (array)json_decode($result);
        if ($ret['success'] == 'false') {
            $err = $this->callErr[$ret['error']];
            return $err;
        }
        return NULL;
    }
}


//error_reporting(E_ALL);
//ini_set('display_errors', 1);


$objBoundio = new SC_Boundio();
$objBoundio->init();
$err = $objBoundio->call();
if ($err == '') {
echo "ok";
} else {
echo "$err";
}


